/*
Matthias Ullmann, Bayreuth Feb. 2016

Some graph theoretical algorithms

using a Linked List and  Adjacency Matrices
 */
#ifndef __graph__
#define __graph__

/* Linked List */

#define AllocNode(a)   {a=(Node *) malloc(sizeof *a);}

/* Node of a linked List */
struct node {int v;
             struct node *next;
            };
typedef struct node Node;

typedef struct{Node *front;
               Node *rear;
	       int n;
              }Queue;

/* Stack operations */
void push(int v, Node *stack);
int pop(Node *stack);

/* Queue Operations */
void  QueueInit(Queue *q);
void PutInQueue(int v, Queue *q);
int  GetFromQueue(Queue *q);
void PrintQueue(Queue *que); 

/* Adjacency List */
Node *NodeVector(long nl, long nh);
void free_NodeVector(Node *v, long nl, long nh);
void PrintAdjList(FILE *fpout, Node *adj, int n);
void r_visit_DFS(Node *adj, int *val, int V, int clust, int m);
void nr_visit_DFS(Node *stack, Node *adj, int *val, int V, int clust, int m);
int listDFS(int *val, Node *adj, int V, int recursive);

void visitBFS(Queue *que, Node *adj, int *val, int V, int clust, int m);
int listBFS(int *val, Node *adj, int V);

int ConnectivityListBTS(int *clust, Node *adj, int V);

/* Adjacency Matrices */
void visitDFS(int **adj, int *val, int V,  int clust, int m);
int ConnectivityMatrixDFS(int *clst, int **adj, int V);


#endif /* __graph__ */
