/* Matthias Ullmann, 02.10.1995				*/
/* Header for predurures calculating properties of 	*/
/* molecules and coordinate manipulations		*/
/*......................................................*/
#include "mol.h"


/* Properties */
double center_of_mass(double **xyz, double *mass, int atomnumber, double *masscenter);
void center(double **xyz, int atomnumber, double *center);
double volume(double **xyz, double *radius, int atomnumber);
double charge(double *charge, int atomnumber);
double dipol(double **xyz, double *charge, int atomnumber, double *masscenter, 
	     double *dipolvec); 
double gyrationradius(double **xyz, int atomnumber, double *masscenter);

double max_dist(double **xyz, int number, double *a, double *dist);

/* Manipulations */
void translation(double **xyz, int atomnumber, double *trans);
void shift_coordinate_center(double **xyz, int n, double *point, double *center);
void rotate(double **xyz, int atomnumber, 
	      double *center_of_rotation, double **rot);
void rotation(double **xyz, int atomnumber, double *center_of_rotation, 
	      double *angles);
void rotation2(double **xyz, int atomnumber, double *vector,
	      double *center_of_rotation, double *angles);
void ori_rotation(double **xyz, int atomnumber, double *angles);
void ori_rotation2(double **xyz, int atomnumber, double *vector,
	      double *angles);
void move(double **oldxyz, int atomnumber, double *trans,
	  double *center_of_rotation, double *angles, 
	  double **newxyz, double *new_center);

void rotate_around_vec(double **xyz, int atomnumber, double *axis, double angle);

double out_of_plane(double *a, double *b, double *c, double *d);
void biomt(double **xyz, int n, double **matrix);


void properties(Mol *mus);
void fprint_properties(FILE *fpout, Mol *mus);

