/* Matthias Ullmann 					*/
/* Bayreuth, Feb 2007                                   */
/*                                                      */
/* Program write a grid-file out as a pdb-file so that  */
/* it can be fewed                                      */
/* .....................................................*/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mol.h"
#include "constants.h"
#include "memutil.h"
#include "util.h"
#include "grid.h"
#include "exclude.h"

/**********************************************************/
int main(int argc, char *argv[])
{
    /* Varialbles */
    cGrid excl;
    FILE *fpin;
    double dummy[4];
    int i,j,k;

    usage("usage: grid2pdb [excl-grid file]",2,argc);

    fpin=file_open(argv[1],"r");


    fread_excl_binary(fpin, &excl);
    cGrid_info(stderr, &excl,"Grid");

    for (i=excl.imin[1];i<=excl.imax[1]; i++)
        for (j=excl.imin[2];j<=excl.imax[2]; j++)
            for (k=excl.imin[3];k<=excl.imax[3]; k++)
                {if (excl.grid[i][j][k]==1) /* i.e. excluded volume */
                    {dummy[1]=(double)i * excl.spacing;
                     dummy[2]=(double)j * excl.spacing;
                     dummy[3]=(double)k * excl.spacing;
                     fprint_DUMMYatom(stdout,1,"DUMM","DUM",dummy, 0.0, 0.0);
                    }
                }


    return 0;
}
