/* ...................................................................*/
/* M. Ullmann, Bayreuth Feb 2004                                      */
/*                                                                    */
/* Program generates a histogram from column data.                    */
/*                                                                    */
/* ...................................................................*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "mathematik.h"
#include "util.h"
#include "memutil.h"



/**********************************************************/
int main(int argc, char *argv[])
{
    /* Varialbles */
    FILE *fpin;
    double *val;
    int *histo;
    double step, test, min, max;
    int n, i, ih;
    long imin, imax; 
    char line[LINELENGTH];

      
    /* Code */
    usage("usage: histogram [file] [step]",argc,3);
    
    step = atof(argv[2]);
    fpin=file_open(argv[1],"r");

    n = 0;
    while (fgets(line, LINELENGTH, fpin) != NULL)
        {if (1==sscanf(line,"%lf",&test)) n++;
        }
    fprintf(stdout,"# %d lines\n",n);
    rewind(fpin);
    val = dvector(1,n);

    i = 0;
    while (fgets(line, LINELENGTH, fpin) != NULL)
        {if (1==sscanf(line,"%lf",&test)) 
            {i++;
             sscanf(line,"%lf",&val[i]);
            }
        }
    fclose(fpin);

    /* now generate the histogram */
    min = min_element(val, n);
    max = max_element(val, n);

    fprintf(stdout,"# Min: %e  Max: %e\n",min,max);

    imin = (long)floor(min/step);
    imax = (long) ceil(max/step);
    fprintf(stdout,"# Histogram Vector: %ld ... %ld\n",imin, imax);

    histo = ivector(imin, imax);
    for (i=imin; i<=imax; i++) {histo[i]=0;}

    for (i=1; i<=n; i++) 
        {ih=(int)rint(val[i]/step);
         if (ih<imin) ERROR("Error 1");
         if (ih>imax) ERROR("Error 2");
         histo[ih]++;
        }
    for (i=imin; i<=imax; i++)
        {fprintf(stdout,"%e %d\n",i*step,histo[i]);
        }

    return 0;
}
