/* Matthias Ullmann 					*/
/* Berlin, 08.11.1995					*/
/*							*/
/* Calculates the exclusion grid around a protein	*/
/* .....................................................*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mathematik.h"
#include "mol.h"
#include "util.h"
#include "exclude.h"


/**********************************************************/
int main(int argc, char *argv[])
{
    /* Varialbles */
    Mol protein;
    double min[4], max[4];
    double rexlmax;
    double probe;
    cGrid excl;

    fprintf(stderr, "Output is written to stdout!!\n");
    usage("make-excl [mus] [probe radius] [spacing]",argc,4);

    read_PQR(argv[1], &protein);
    probe=atof(argv[2]);
    excl.spacing=atof(argv[3]);

    /* looking for the atoms with the largest and the smallest coordinates */
    min_max_coord(min, max, protein.xyz, protein.natoms);

    /* the grid should be a little bit larger than the extention of	*/
    /* protein. It must be larger about the same extention as 	*/
    /* rexlmax: Atom radius of protein1 + atomradius of protein2	*/
    /* (for protein2 averaged radius)				*/
    /* Here is the place, where the docking can be softed		*/
    rexlmax=max_element(protein.radius, protein.natoms) + probe;

    max[1]=max[1]+rexlmax; max[2]=max[2]+rexlmax; max[3]=max[3]+rexlmax; 
    min[1]=min[1]-rexlmax; min[2]=min[2]-rexlmax; min[3]=min[3]-rexlmax; 
    excl_to_grid(&excl, probe, min, max, protein.xyz, 
	     protein.radius, protein.natoms);
    fprint_excl_binary(stdout,&excl);

    return 0;
}
