/* ...................................................................*/
/* M. Ullmann, Bayreuth January 2004                                  */
/*                                                                    */
/* Program determines the minimium distance between to pdb files.     */
/*                                                                    */
/* ...................................................................*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "mol.h"
#include "mathematik.h"
#include "util.h"



/**********************************************************/
int main(int argc, char *argv[])
{
      /* Varialbles */
      Mol p1, p2;
      double dist, mindist=DBL_MAX;
      int i, j=0, isav=-1, jsav=-1;
      
      /* Code */
      usage("usage: min-dist [pdb1] [pdb2]",argc,3);
      
      read_PDB(argv[1], &p1);
      read_PDB(argv[2], &p2);

      if (0!=strcmp(argv[1], argv[2]))
         {for (i=1; i<=p1.natoms; i++)
              {for (j=1; j<=p2.natoms; j++)
                  {dist=Distance(p1.xyz[i],p2.xyz[j]);
                   if (dist<mindist)
                       {mindist=dist;
                        isav=i; jsav=j;
                       }
                  }
              }
         }
      else {for (i=1; i<=p1.natoms; i++)
              {for (j=1; j<i; j++)
                  {dist=Distance(p1.xyz[i],p2.xyz[j]);
                   if (dist<mindist)
                       {mindist=dist;
                        isav=i; jsav=j;
                       }
                  }
              }
           }
      
      
      fprintf(stdout,"Minimum Distance is %.3f between atoms i=%d j=%d\n",mindist, i,j);
      fprint_PDBatom(stdout,&p1,isav);
      fprint_PDBatom(stdout,&p2,jsav);
      
      return 0;
}
