/* Matthias Ullmann 					*/
/* Berlin, 08.11.1995					*/
/*							*/
/* Shifts the protein in a way to have the coordinate   */
/* center at the origin.	                        */
/* .....................................................*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mol.h"
#include "properties.h"
#include "util.h"

/**********************************************************/
int main(int argc, char *argv[])
{
    /* Varialbles */
    Mol protein;
    double cm[4], ori[4]={0.0,0.0,0.0,0.0};
    //double geocenter[4];

    usage("shift-center [pqrm]",argc,2);

    read_PQRM(argv[1], &protein);
    center_of_mass(protein.xyz, protein.mass,
                   protein.natoms, cm);
    shift_coordinate_center(protein.xyz,protein.natoms,ori,cm);
    //center(protein.xyz, protein.number_of_atoms, geocenter);
    //shift_center(&protein, ori, geocenter);

    fprint_PQRM(stdout, &protein);

    return 0;
}
