/* Matthias Ullmann, 2016				*/
/*                                                      */
/* treat fasta files         			        */
/*......................................................*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mol.h"
#include "util.h"
#include "memutil.h"

/* ------------------------------------------------------------	*/
/* read a fasta-file with mutliple enties                       */
/*                                                              */
void ReadFASTA(fasta *s, char const *name)
{
  FILE *fp;
  int n;
  unsigned int i;
  char line[LINELENGTH];

  fp=file_open(name,"r");
  /* scan to count the number of entries */
  (*s).nseq=0;
  while (fgets(line,LINELENGTH,fp)!=NULL)
        if (line[0]=='>') (*s).nseq++;

  /* allocate the memory */ 
  (*s).title = charmatrix(1,(*s).nseq,0,LINELENGTH);
  (*s).seq   = charmatrix(1,(*s).nseq,0,LINELENGTH);
  (*s).nres  = ivector(1,(*s).nseq);   
     
  /* read the information */
  rewind(fp);
  n = 0;
  while (fgets(line,LINELENGTH,fp)!=NULL)
    {if (line[0]=='>') 
	{/* read the title */
         n++;
	 strcpy((*s).title[n],line);
	 (*s).nres[n] = 0;
	}
      else {/* read the sequence */
	    for (i=0; i<(strlen(line)-1); i++)
	         {(*s).seq[n][(*s).nres[n]]=line[i];
		  (*s).nres[n]++;
		  if ((*s).nres[n]==MAXRES) 
		    muerror("MAXRES too small, sequence to long\n");
		 }
           }
    }
  /* add '\0' to the end of the sequences */
  for (n=1; n<=(*s).nseq; n++) (*s).seq[n][(*s).nres[n]]='\0';

  fclose(fp);
}
/* ------------------------------------------------------------	*/
/* write a fasta-file with multiple enties                      */
/*                                                              */
void WriteFASTA(FILE *fp, fasta *s)
{
  int n,i;

  for (n=1; n<=(*s).nseq; n++)
      {fprintf(fp,"%s",(*s).title[n]);
       for (i=0; i<(*s).nres[n]; i++)
	   {fprintf(fp,"%c",(*s).seq[n][i]);
	     if (((1+i)%LNRES)==0) fprintf(fp,"\n");
	   }
       fprintf(fp,"\n");
      }  

}
